diff --git a/src/main/java/net/minecraft/client/world/WorldClient.java b/src/main/java/net/minecraft/client/world/WorldClient.java
index ca6cd0d75..8b8c932a3 100644
--- a/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.world;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.net.handler.NetClientHandler;
+import net.minecraft.client.net.handler.ClientPacketHandler;
 import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.packet.Packet255KickDisconnect;
+import net.minecraft.core.net.packet.DisconnectPacket;
+import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.core.world.pathfinder.IdHashMap;
 import net.minecraft.core.world.save.SaveHandlerClientMP;
 
 import java.util.HashSet;
@@ -19,26 +19,27 @@ import java.util.Set;
 
 // Referenced classes of package net.minecraft.src:
 //            World, SaveHandlerMP, WorldProvider, MCHash, 
-//            ChunkCoordinates, NetClientHandler, IWorldAccess, Entity, 
-//            WorldBlockPositionType, ChunkProviderClient, Packet255KickDisconnect, WorldInfo, 
+//            ChunkCoordinates, ClientPacketHandler, IWorldAccess, Entity,
+//            WorldBlockPositionType, ChunkProviderClient, DisconnectPacket, WorldInfo,
 //            IChunkProvider
 
 public class WorldClient extends World {
     private final Minecraft mc;
     private final LinkedList<WorldBlockPositionType> positionTypesList;
-    private final NetClientHandler sendQueue;
-    private ChunkProviderClient field_20915_C;
-    private final IdHashMap<Entity> entityMap;
-    private final Set<Entity> field_20914_E;
-    private final Set<Entity> field_1053_F;
-    public WorldClient(Minecraft minecraft, NetClientHandler netclienthandler, long seed, int dimensionId, int worldTypeId)
+    private final ClientPacketHandler sendQueue;
+    private ChunkProviderClient chunkCache;
+    private final IntHashMap<Entity> entitiesById;
+    private final Set<Entity> forced;
+    private final Set<Entity> reEntries;
+
+    public WorldClient(Minecraft minecraft, ClientPacketHandler netclienthandler, long seed, int dimensionId, int worldTypeId)
     {
         super(new SaveHandlerClientMP(), "MpServer", Dimension.getDimensionList().get(dimensionId), Registries.WORLD_TYPES.getItemByNumericId(worldTypeId), seed);
         this.mc = minecraft;
         positionTypesList = new LinkedList<>();
-        entityMap = new IdHashMap<>();
-        field_20914_E = new HashSet<>();
-        field_1053_F = new HashSet<>();
+        entitiesById = new IntHashMap<>();
+        forced = new HashSet<>();
+        reEntries = new HashSet<>();
         sendQueue = netclienthandler;
         setSpawnPoint(new ChunkCoordinates(8, 64, 8));
         savedDataStorage = netclienthandler.savedDataStorage;
@@ -47,9 +48,9 @@ public class WorldClient extends World {
     @Override
 	public void tick()
     {
-        for(int k = 0; k < 10 && !field_1053_F.isEmpty(); k++)
+        for(int k = 0; k < 10 && !reEntries.isEmpty(); k++)
         {
-            Entity entity = field_1053_F.iterator().next();
+            Entity entity = reEntries.iterator().next();
             if(!loadedEntityList.contains(entity))
             {
                 entityJoinedWorld(entity);
@@ -71,7 +72,7 @@ public class WorldClient extends World {
     }
 
     public void processPackets() {
-        sendQueue.processReadPackets();
+        sendQueue.tick();
     }
 
     public void func_711_c(int i, int j, int k, int l, int i1, int j1)
@@ -90,8 +91,8 @@ public class WorldClient extends World {
     @Override
 	protected IChunkProvider createChunkProvider()
     {
-        field_20915_C = new ChunkProviderClient(this);
-        return field_20915_C;
+        chunkCache = new ChunkProviderClient(this);
+        return chunkCache;
     }
 
     @Override
@@ -120,10 +121,10 @@ public class WorldClient extends World {
     {
         if(flag)
         {
-            field_20915_C.prepareChunk(i, j);
+            chunkCache.prepareChunk(i, j);
         } else
         {
-            field_20915_C.func_539_c(i, j);
+            chunkCache.func_539_c(i, j);
         }
         if(!flag)
         {
@@ -135,10 +136,10 @@ public class WorldClient extends World {
 	public boolean entityJoinedWorld(Entity entity)
     {
         boolean flag = super.entityJoinedWorld(entity);
-        field_20914_E.add(entity);
+        forced.add(entity);
         if(!flag)
         {
-            field_1053_F.add(entity);
+            reEntries.add(entity);
         }
         return flag;
     }
@@ -147,23 +148,23 @@ public class WorldClient extends World {
 	public void setEntityDead(Entity entity)
     {
         super.setEntityDead(entity);
-        field_20914_E.remove(entity);
+        forced.remove(entity);
     }
 
     @Override
 	protected void obtainEntitySkin(Entity entity)
     {
         super.obtainEntitySkin(entity);
-        field_1053_F.remove(entity);
+        reEntries.remove(entity);
     }
 
     @Override
 	protected void releaseEntitySkin(Entity entity)
     {
         super.releaseEntitySkin(entity);
-        if(field_20914_E.contains(entity))
+        if(forced.contains(entity))
         {
-            field_1053_F.add(entity);
+            reEntries.add(entity);
         }
     }
 
@@ -174,26 +175,26 @@ public class WorldClient extends World {
         {
             setEntityDead(entity1);
         }
-        field_20914_E.add(entity);
+        forced.add(entity);
         entity.id = i;
         if(!entityJoinedWorld(entity))
         {
-            field_1053_F.add(entity);
+            reEntries.add(entity);
         }
-        entityMap.add(i, entity);
+        entitiesById.put(i, entity);
     }
 
     public Entity getEntityFromId(int i)
     {
-        return entityMap.get(i);
+        return entitiesById.get(i);
     }
 
     public Entity removeEntityFromWorld(int i)
     {
-        Entity entity = entityMap.remove(i);
+        Entity entity = entitiesById.remove(i);
         if(entity != null)
         {
-            field_20914_E.remove(entity);
+            forced.remove(entity);
             setEntityDead(entity);
         }
         return entity;
@@ -260,7 +261,7 @@ public class WorldClient extends World {
     @Override
 	public void sendQuittingDisconnectingPacket()
     {
-        sendQueue.func_28117_a(new Packet255KickDisconnect("Quitting"));
+        sendQueue.func_28117_a(new DisconnectPacket("Quitting"));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/Global.java b/src/main/java/net/minecraft/core/Global.java
index 6016c6a89..0acd8a3fc 100644
--- a/src/main/java/net/minecraft/core/Global.java
+++ b/src/main/java/net/minecraft/core/Global.java
@@ -2,6 +2,7 @@ package net.minecraft.core;
 
 public class Global
 {
+	public static final int TICKS_PER_SECOND = 20;
 	public static final int DAY_LENGTH_TICKS = 24000;
 	public static final String VERSION = Version.BUILD_CHANNEL.modifyVersionString(Version.VERSION);
 	public static final String BUILD_TIME = Version.BUILD_TIME;
diff --git a/src/main/java/net/minecraft/core/NextTickListEntry.java b/src/main/java/net/minecraft/core/NextTickListEntry.java
index e3745eab1..997d58af5 100644
--- a/src/main/java/net/minecraft/core/NextTickListEntry.java
+++ b/src/main/java/net/minecraft/core/NextTickListEntry.java
@@ -47,26 +47,20 @@ public class NextTickListEntry
         return this;
     }
 
-    public int comparer(NextTickListEntry entry)
-    {
-        if(delay < entry.delay)
+    @Override
+	public int compareTo(NextTickListEntry other) {
+        if(delay < other.delay)
         {
             return -1;
         }
-        if(delay > entry.delay)
+        if(delay > other.delay)
         {
             return 1;
         }
-        if(c < entry.c)
+        if(c < other.c)
         {
             return -1;
         }
-        return c <= entry.c ? 0 : 1;
-    }
-
-    @Override
-	public int compareTo(NextTickListEntry that)
-    {
-        return comparer(that);
+        return c <= other.c ? 0 : 1;
     }
 }
diff --git a/src/main/java/net/minecraft/core/WeightedRandomBag.java b/src/main/java/net/minecraft/core/WeightedRandomBag.java
index ce9a5eb3a..d0e1c8195 100644
--- a/src/main/java/net/minecraft/core/WeightedRandomBag.java
+++ b/src/main/java/net/minecraft/core/WeightedRandomBag.java
@@ -73,4 +73,9 @@ public class WeightedRandomBag<T> {
         }
         return (weight / accumulatedWeight) * 100;
     }
+
+    public void clear(){
+        entries.clear();
+        accumulatedWeight = 0;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/WeightedRandomLootObject.java b/src/main/java/net/minecraft/core/WeightedRandomLootObject.java
index 222a7a6e1..27161f55f 100644
--- a/src/main/java/net/minecraft/core/WeightedRandomLootObject.java
+++ b/src/main/java/net/minecraft/core/WeightedRandomLootObject.java
@@ -1,21 +1,23 @@
 package net.minecraft.core;
 
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
 public class WeightedRandomLootObject {
-    private ItemStack itemStack;
+    @Nullable
+    private final ItemStack itemStack;
     private int yieldMin;
     private int yieldMax;
     private int yieldFixed;
-    private boolean isRandomYield;
+    private final boolean isRandomYield;
     private int metaMin;
     private int metaMax;
     private boolean isRandomMeta;
     private final Random random = new Random();
 
-    public WeightedRandomLootObject(ItemStack itemStack, int yieldMin, int yieldMax){
+    public WeightedRandomLootObject(@Nullable ItemStack itemStack, int yieldMin, int yieldMax){
         this.itemStack = itemStack;
         this.yieldMin = yieldMin;
         this.yieldMax = yieldMax;
@@ -23,14 +25,14 @@ public class WeightedRandomLootObject {
         this.isRandomMeta = false;
     }
 
-    public WeightedRandomLootObject(ItemStack itemStack, int yieldFixed){
+    public WeightedRandomLootObject(@Nullable ItemStack itemStack, int yieldFixed){
         this.itemStack = itemStack;
         this.yieldFixed = yieldFixed;
         this.isRandomYield = false;
         this.isRandomMeta = false;
     }
 
-    public WeightedRandomLootObject(ItemStack itemStack){
+    public WeightedRandomLootObject(@Nullable ItemStack itemStack){
         this.itemStack = itemStack;
         this.yieldFixed = 1;
         this.isRandomYield = false;
@@ -77,10 +79,12 @@ public class WeightedRandomLootObject {
     public boolean isRandomMeta(){
         return isRandomMeta;
     }
+    @Nullable
     public ItemStack getItemStack(){
         return getItemStack(random);
     }
 
+    @Nullable
     public ItemStack getItemStack(Random random){
         if (itemStack == null) return null;
         int amount;
diff --git a/src/main/java/net/minecraft/core/achievement/Achievement.java b/src/main/java/net/minecraft/core/achievement/Achievement.java
index f16aa54d6..2324e211c 100644
--- a/src/main/java/net/minecraft/core/achievement/Achievement.java
+++ b/src/main/java/net/minecraft/core/achievement/Achievement.java
@@ -1,74 +1,66 @@
 package net.minecraft.core.achievement;
 
-import net.minecraft.core.achievement.stat.IStatStringFormat;
+import net.minecraft.client.gui.achievements.data.AchievementPage;
+import net.minecraft.core.achievement.stat.StatDescFormatter;
 import net.minecraft.core.achievement.stat.Stat;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.IItemConvertible;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.collection.NamespaceID;
 
 public class Achievement extends Stat
 {
+    public static final Type TYPE_NORMAL = new Type("minecraft:gui/achievement/achievement", 0xffffffff, 0xff808080, false);
+    public static final Type TYPE_SPECIAL = new Type("minecraft:gui/achievement/achievement_special", 0xffffff80, 0xff808040, false);
+    public static final Type TYPE_SECRET = new Type("minecraft:gui/achievement/achievement_secret", 0xff8080ff, 0xff404080, true);
 
     public final int x;
     public final int y;
     public final Achievement parent;
     private final String description;
-    private IStatStringFormat statStringFormatter;
-    public final int itemId;
-    private boolean isSpecial;
+    private StatDescFormatter statStringFormatter;
+    public final int iconItemId;
+    private Type type = TYPE_NORMAL;
 
-    public Achievement(int id, String name, int x, int y, Item item, Achievement parent)
+    public Achievement(NamespaceID id, String name, int x, int y, IItemConvertible icon, Achievement parent)
     {
-        this(id, name, x, y, item.id, parent);
+        this(id, name, x, y, icon.asItem().id, parent);
     }
 
-    public Achievement(int i, String name, int x, int y, Block block, Achievement parent)
+    public Achievement(NamespaceID id, String name, int x, int y, int iconItemId, Achievement parent)
     {
-        this(i, name, x, y, block.id, parent);
-    }
-
-    public Achievement(int id, String name, int x, int y, int itemId, Achievement parent)
-    {
-        super(0x500000 + id, "achievement." + name);
-        this.itemId = itemId;
+        super(new NamespaceID(id.namespace, "achievement/" + id.value), "achievement." + name);
+        this.iconItemId = iconItemId;
         this.description = "achievement." + name;
         this.x = x;
         this.y = y;
-        if(x < AchievementList.minX)
-        {
-            AchievementList.minX = x;
-        }
-        if(y < AchievementList.minY)
-        {
-            AchievementList.minY = y;
-        }
-        if(x > AchievementList.maxX)
-        {
-            AchievementList.maxX = x;
-        }
-        if(y > AchievementList.maxY)
-        {
-            AchievementList.maxY = y;
-        }
+
+        Achievements.minX = Math.min(Achievements.minX, x);
+        Achievements.maxX = Math.max(Achievements.maxX, x);
+        Achievements.minY = Math.min(Achievements.minY, y);
+        Achievements.maxY = Math.max(Achievements.maxY, y);
+
         this.parent = parent;
     }
 
-    public Achievement setClientsideAchievement()
-    {
+    public Achievement setClientsideAchievement() {
         clientside = true;
         return this;
     }
 
-    public Achievement setSpecial()
-    {
-        isSpecial = true;
+    public Achievement setType(Type type) {
+        this.type = type;
         return this;
     }
 
-    public Achievement registerAchievement()
-    {
+    public Achievement registerAchievement() {
         super.registerStat();
-        AchievementList.achievementList.add(this);
+        Achievements.achievementList.add(this);
+        return this;
+    }
+    public Achievement addToPage(AchievementPage ... pages){
+        for (AchievementPage page : pages){
+            page.addAchievement(this);
+        }
         return this;
     }
 
@@ -89,15 +81,13 @@ public class Achievement extends Stat
         }
     }
 
-    public Achievement setStatStringFormatter(IStatStringFormat istatstringformat)
-    {
-        statStringFormatter = istatstringformat;
+    public Achievement setDescriptionFormatter(StatDescFormatter descFormatter) {
+        statStringFormatter = descFormatter;
         return this;
     }
 
-    public boolean getSpecial()
-    {
-        return isSpecial;
+    public Type getType() {
+        return type;
     }
 
     @Override
@@ -111,4 +101,17 @@ public class Achievement extends Stat
     {
         return setClientsideAchievement();
     }
+
+    public static class Type {
+        public final String texture;
+        public final int colorName;
+        public final int colorNameLocked;
+        public final boolean hidden;
+        public Type(String texture, int colorName, int colorNameLocked, boolean hidden){
+            this.texture = texture;
+            this.colorName = colorName;
+            this.colorNameLocked = colorNameLocked;
+            this.hidden = hidden;
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/achievement/Achievements.java b/src/main/java/net/minecraft/core/achievement/Achievements.java
new file mode 100644
index 000000000..cc6c6de70
--- /dev/null
+++ b/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -0,0 +1,129 @@
+package net.minecraft.core.achievement;
+
+import net.minecraft.client.gui.achievements.data.AchievementPages;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.collection.NamespaceID;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public abstract class Achievements
+{
+    
+    public static List<Achievement> achievementList = new ArrayList<>();
+    public static int minX;
+    public static int minY;
+    public static int maxX;
+    public static int maxY;
+    public static Achievement OPEN_INVENTORY =
+        new Achievement(new NamespaceID("minecraft", "open_inventory"), "openInventory", 0, 0, Items.BOOK, null)
+        .setClientsideAchievement().registerAchievement()
+        .addToPage(AchievementPages.overworldPage);
+    public static Achievement MINE_WOOD =
+        new Achievement(new NamespaceID("minecraft", "mine_wood"), "mineWood", 2, 1, Blocks.LOG_OAK, OPEN_INVENTORY)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage, AchievementPages.netherPage);
+    public static Achievement BUILD_WORKBENCH =
+        new Achievement(new NamespaceID("minecraft", "build_workbench"), "buildWorkBench", 4, -1, Blocks.WORKBENCH, MINE_WOOD)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage, AchievementPages.netherPage);
+    public static Achievement BUILD_PICKAXE =
+        new Achievement(new NamespaceID("minecraft", "build_pickaxe"), "buildPickaxe", 4, 2, Items.TOOL_PICKAXE_WOOD, BUILD_WORKBENCH)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage, AchievementPages.netherPage);
+    public static Achievement BUILD_FURNACE =
+        new Achievement(new NamespaceID("minecraft", "build_furnace"), "buildFurnace", 3, 4, Blocks.FURNACE_STONE_ACTIVE, BUILD_PICKAXE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement ACQUIRE_IRON =
+        new Achievement(new NamespaceID("minecraft", "acquire_iron"), "acquireIron", 1, 4, Items.INGOT_IRON, BUILD_FURNACE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement BUILD_HOE =
+        new Achievement(new NamespaceID("minecraft", "build_hoe"), "buildHoe", 2, -3, Items.TOOL_HOE_WOOD, BUILD_WORKBENCH)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement MAKE_BREAD =
+        new Achievement(new NamespaceID("minecraft", "make_bread"), "makeBread", -1, -3, Items.FOOD_BREAD, BUILD_HOE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement BAKE_CAKE =
+        new Achievement(new NamespaceID("minecraft", "bake_cake"), "bakeCake", 0, -5, Items.FOOD_CAKE, BUILD_HOE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement BUILD_BETTER_PICKAXE =
+        new Achievement(new NamespaceID("minecraft", "build_better_pickaxe"), "buildBetterPickaxe", 6, 2, Items.TOOL_PICKAXE_STONE, BUILD_PICKAXE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement COOK_FISH =
+        new Achievement(new NamespaceID("minecraft", "cook_fish"), "cookFish", 2, 6, Items.FOOD_FISH_COOKED, BUILD_FURNACE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement ON_A_RAIL =
+        new Achievement(new NamespaceID("minecraft", "on_a_rail"), "onARail", 2, 3, Blocks.RAIL, ACQUIRE_IRON)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement BUILD_SWORD =
+        new Achievement(new NamespaceID("minecraft", "build_sword"), "buildSword", 6, -1, Items.TOOL_SWORD_WOOD, BUILD_WORKBENCH)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement KILL_ENEMY =
+        new Achievement(new NamespaceID("minecraft", "kill_enemy"), "killEnemy", 8, -1, Items.BONE, BUILD_SWORD)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement KILL_COW =
+        new Achievement(new NamespaceID("minecraft", "kill_cow"), "killCow", 7, -3, Items.LEATHER, BUILD_SWORD)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement FLY_PIG =
+        new Achievement(new NamespaceID("minecraft", "fly_pig"), "flyPig", 8, -4, Items.SADDLE, KILL_COW)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement GET_SENSED =
+        new Achievement(new NamespaceID("minecraft", "get_sensed"), "getSensed", 10, -1, Blocks.MOTION_SENSOR_ACTIVE, KILL_ENEMY)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement CRAFT_HANDCANNON =
+        new Achievement(new NamespaceID("minecraft", "craft_hand_cannon"), "craftHandCannon", 8, 2, Items.HANDCANNON_UNLOADED, BUILD_BETTER_PICKAXE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement COLLECT_STONE =
+        new Achievement(new NamespaceID("minecraft", "collect_stone"), "collectStone", 5, 4, Blocks.COBBLE_LIMESTONE, BUILD_PICKAXE)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement CRUSH_BLOCKS =
+        new Achievement(new NamespaceID("minecraft", "crush_blocks"), "crushBlocks", 7, 4, Blocks.ICE, BUILD_BETTER_PICKAXE)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement REPAIR_ARMOR =
+        new Achievement(new NamespaceID("minecraft", "repair_armor"), "repairArmor", 12, -1, Items.CHAINLINK, GET_SENSED)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement GET_CHAINMAIL =
+        new Achievement(new NamespaceID("minecraft", "get_chainmail"), "getChainmail", 14, -1, Items.ARMOR_HELMET_CHAINMAIL, REPAIR_ARMOR)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement OPEN_GUIDEBOOK =
+        new Achievement(new NamespaceID("minecraft", "open_guidebook"), "openGuidebook", 0, 2, Blocks.BOOKSHELF_PLANKS_OAK, OPEN_INVENTORY)
+            .setClientsideAchievement()
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+    public static Achievement CAUGHT_EM_ALL =
+        new Achievement(new NamespaceID("minecraft", "caught_em_all"), "caughtEmAll", 4, -4, Items.LANTERN_FIREFLY_GREEN, BUILD_WORKBENCH)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement()
+            .addToPage(AchievementPages.overworldPage);
+
+    private static boolean hasInit = false;
+    public static void init() {
+        if (hasInit) return;
+        hasInit = true;
+        AchievementPages.init();
+        System.out.println(achievementList.size() + " Achievements");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/achievement/stat/DistanceValueFormatter.java b/src/main/java/net/minecraft/core/achievement/stat/DistanceValueFormatter.java
new file mode 100644
index 000000000..a3b2418b5
--- /dev/null
+++ b/src/main/java/net/minecraft/core/achievement/stat/DistanceValueFormatter.java
@@ -0,0 +1,24 @@
+package net.minecraft.core.achievement.stat;
+
+// Referenced classes of package net.minecraft.src:
+//            StatValueFormatter, StatBase
+
+final class DistanceValueFormatter implements StatValueFormatter {
+    public static double UNIT_CENTIMETER_TO_METER = 1d/100;
+    public static double UNIT_METER_TO_KILOMETER = 1d/1000;
+
+    @Override
+	public String formatValue(int value)
+    {
+        double meters = value * UNIT_CENTIMETER_TO_METER;
+        double kilometers = meters * UNIT_METER_TO_KILOMETER;
+        if(kilometers > 0.5D) {
+            return Stat.getDecimalFormat().format(kilometers) + " km";
+        }
+        if(meters > 0.5D) {
+            return Stat.getDecimalFormat().format(meters) + " m";
+        } else {
+            return value + " cm";
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/achievement/stat/SimpleValueFormatter.java b/src/main/java/net/minecraft/core/achievement/stat/SimpleValueFormatter.java
new file mode 100644
index 000000000..73bd925dd
--- /dev/null
+++ b/src/main/java/net/minecraft/core/achievement/stat/SimpleValueFormatter.java
@@ -0,0 +1,13 @@
+package net.minecraft.core.achievement.stat;
+
+// Referenced classes of package net.minecraft.src:
+//            StatValueFormatter, StatBase
+
+final class SimpleValueFormatter implements StatValueFormatter {
+
+    @Override
+	public String formatValue(int value)
+    {
+        return Stat.getNumberFormat().format(value);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/achievement/stat/Stat.java b/src/main/java/net/minecraft/core/achievement/stat/Stat.java
index f1ca08bc0..0b4e4f960 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/Stat.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/Stat.java
@@ -1,8 +1,12 @@
 package net.minecraft.core.achievement.stat;
 
-import net.minecraft.core.achievement.AchievementMap;
+import com.b100.utils.StreamUtils;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.collection.NamespaceID;
 
+import java.io.BufferedReader;
+import java.io.InputStream;
+import java.io.InputStreamReader;
 import java.text.DecimalFormat;
 import java.text.NumberFormat;
 import java.util.*;
@@ -10,33 +14,34 @@ import java.util.*;
 public class Stat
 {
 
-    public final int statId;
-    final String statName;
+    private static final NumberFormat numberFormat = NumberFormat.getIntegerInstance(Locale.US);
+    public static StatValueFormatter statTypeSimple = new SimpleValueFormatter();
+    private static final DecimalFormat decimalFormat = new DecimalFormat("########0.00");
+    public static StatValueFormatter statTypeTime = new TimeValueFormatter();
+    public static StatValueFormatter statTypeDistance = new DistanceValueFormatter();
+
+    public final NamespaceID statId;
+    final String statKey;
     public boolean clientside;
-    public String statGuid;
-    private final IStatType statType;
-    private static NumberFormat numberFormat = NumberFormat.getIntegerInstance(Locale.US);
-    public static IStatType statTypeSimple = new StatTypeSimple();
-    private static DecimalFormat decimalFormat = new DecimalFormat("########0.00");
-    public static IStatType statTypeTime = new StatTypeTime();
-    public static IStatType statTypeDistance = new StatTypeDistance();
-
-    public Stat(int id, String name, IStatType statType)
+//    public String UUID;
+    private final StatValueFormatter statType;
+
+    public Stat(NamespaceID id, String key, StatValueFormatter statType)
     {
         clientside = false;
         statId = id;
-        statName = name;
+        statKey = key;
         this.statType = statType;
     }
 
-    public Stat(int id, String name)
+    public Stat(NamespaceID id, String key)
     {
-        this(id, name, statTypeSimple);
+        this(id, key, statTypeSimple);
     }
 
     public String getStatName()
     {
-        return I18n.getInstance().translateKey(statName);
+        return I18n.getInstance().translateKey(statKey);
     }
 
     public Stat setClientside()
@@ -47,14 +52,14 @@ public class Stat
 
     public Stat registerStat()
     {
-        if (StatList.statMap.containsKey(Integer.valueOf(statId)))
+        if (StatList.statMap.containsKey(statId))
         {
-            throw new RuntimeException((new StringBuilder()).append("Duplicate stat id: \"").append(((Stat) StatList.statMap.get(Integer.valueOf(statId))).getStatName()).append("\" and \"").append(statName).append("\" at id ").append(statId).toString());
+            throw new RuntimeException("Duplicate stat id: \"" + StatList.statMap.get(statId).getStatName() + "\" and \"" + statKey + "\" at id " + statId);
         } else
         {
-            StatList.statList1.add(this);
-            StatList.statMap.put(Integer.valueOf(statId), this);
-            statGuid = AchievementMap.getGuid(statId);
+            StatList.registeredStats.add(this);
+            StatList.statMap.put(statId, this);
+//            UUID = UUIDs.get(statId);
             return this;
         }
     }
@@ -64,15 +69,15 @@ public class Stat
         return false;
     }
 
-    public String makeString(int i)
+    public String getFormattedValue(int value)
     {
-        return statType.makeString(i);
+        return statType.formatValue(value);
     }
 
     @Override
 	public String toString()
     {
-        return statName;
+        return statKey;
     }
 
     static NumberFormat getNumberFormat()
@@ -85,4 +90,44 @@ public class Stat
         return decimalFormat;
     }
 
+//    public static class UUIDs
+//    {
+//
+//        private static final UUIDs instance = new UUIDs();
+//        private final Map<NamespaceID, String> ID_TO_UUID_MAP;
+//
+//        private UUIDs()
+//        {
+//            BufferedReader bufferedreader = null;
+//            InputStream stream = null;
+//            ID_TO_UUID_MAP = new HashMap<>();
+//            try
+//            {
+//                stream = this.getClass().getResourceAsStream("/achievement/map.txt");
+//                bufferedreader = new BufferedReader(new InputStreamReader(stream));
+//                String line;
+//                while((line = bufferedreader.readLine()) != null)
+//                {
+//                    String[] ls = line.split(",");
+//                    try {
+//                        ID_TO_UUID_MAP.put(new NamespaceID(ls[0]), ls[1]);
+//                    } catch (IllegalArgumentException illegalArgumentException){
+//                        illegalArgumentException.printStackTrace();
+//                    }
+//                }
+//                bufferedreader.close();
+//            } catch (Exception exception)
+//            {
+//                exception.printStackTrace();
+//            } finally
+//            {
+//                StreamUtils.close(stream, bufferedreader);
+//            }
+//        }
+//
+//        public static String get(NamespaceID statID)
+//        {
+//            return instance.ID_TO_UUID_MAP.get(statID);
+//        }
+//    }
 }
